﻿using System.Collections.ObjectModel;
using System.Drawing;
using System.Windows.Forms;
using System.Collections.Generic;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace DraggedPointStyle
{
    class DragInteractiveOverlay : EditInteractiveOverlay
    {

      PointStyle normalControlPointStyle =  new PointStyle(PointSymbolType.Square, new GeoSolidBrush(GeoColor.StandardColors.White), new GeoPen(GeoColor.StandardColors.Black), 10);
      PointStyle draggedControlPointStyle = new PointStyle(PointSymbolType.Triangle, new GeoSolidBrush(GeoColor.StandardColors.Green), 10);

        //Overrides the DrawCore function.
        protected override void DrawCore(GeoCanvas canvas)
        {
            //Draws the Edit Shapes as default.
            Collection<SimpleCandidate> labelsInAllLayers = new Collection<SimpleCandidate>();
            EditShapesLayer.Open();
            EditShapesLayer.Draw(canvas, labelsInAllLayers);
            //Draws the Drag/Rotate/Resize ControlPoints as default
            DragControlPointsLayer.Open();
            DragControlPointsLayer.Draw(canvas, labelsInAllLayers);
            RotateControlPointsLayer.Open();
            RotateControlPointsLayer.Draw(canvas, labelsInAllLayers);
            ResizeControlPointsLayer.Open();
            ResizeControlPointsLayer.Draw(canvas, labelsInAllLayers);
            canvas.Flush();         
           
            //Draws the control points. 
            ExistingControlPointsLayer.Open();
            Collection<Feature> controlPoints = ExistingControlPointsLayer.FeatureSource.GetAllFeatures(ReturningColumnsType.AllColumns);

            //Loops thru the control points.
            foreach (Feature feature in controlPoints)
            {
                //Looks at the value of "state" to draw the control point as dragged or not.
                if (feature.ColumnValues["state"] != "selected")
                {
                    Feature[] features = new Feature[1] { feature };
                    normalControlPointStyle.Draw(features, canvas, labelsInAllLayers, labelsInAllLayers);
                }
                else
                {
                    Feature[] features = new Feature[1] { feature };
                    draggedControlPointStyle.Draw(features, canvas, labelsInAllLayers, labelsInAllLayers);
                }
            }
        }
     }
 }
